Index: src/Actions/SelectionAction/NotAtomByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotAtomByIdAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/NotAtomByIdAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,38 @@
+/*
+ * NotAtomByIdAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef NOTATOMBYIDACTION_HPP_
+#define NOTATOMBYIDACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class atom;
+
+void SelectionNotAtomById(atom *_atom);
+
+class SelectionNotAtomByIdAction : public Action {
+  friend void SelectionNotAtomById(atom *_atom);
+
+public:
+  SelectionNotAtomByIdAction();
+  virtual ~SelectionNotAtomByIdAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* NOTATOMBYIDACTION_HPP_ */
Index: src/Actions/SelectionAction/NotMoleculeByFormulaAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByFormulaAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/NotMoleculeByFormulaAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,110 @@
+/*
+ * NotMoleculeByFormulaAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/SelectionAction/NotMoleculeByFormulaAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/MoleculeFormulaDescriptor.hpp"
+#include "molecule.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// memento to remember the state when undoing
+
+class SelectionNotMoleculeByFormulaState : public ActionState {
+public:
+  SelectionNotMoleculeByFormulaState(std::vector<molecule*> selectedMolecules, const std::string &_formula) :
+    selectedMolecules(selectedMolecules),
+    formula(_formula)
+  {}
+  std::vector<molecule*> selectedMolecules;
+  std::string formula;
+};
+
+const char SelectionNotMoleculeByFormulaAction::NAME[] = "unselect-molecule-by-formula";
+
+SelectionNotMoleculeByFormulaAction::SelectionNotMoleculeByFormulaAction() :
+  Action(NAME)
+{}
+
+SelectionNotMoleculeByFormulaAction::~SelectionNotMoleculeByFormulaAction()
+{}
+
+void SelectionNotMoleculeByFormula(const std::string &_formula) {
+  ValueStorage::getInstance().setCurrentValue(SelectionNotMoleculeByFormulaAction::NAME, _formula);
+  ActionRegistry::getInstance().getActionByName(SelectionNotMoleculeByFormulaAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* SelectionNotMoleculeByFormulaAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
+Action::state_ptr SelectionNotMoleculeByFormulaAction::performCall() {
+  std::string formula;
+  std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
+
+  ValueStorage::getInstance().queryCurrentValue(NAME, formula);
+
+  DoLog(1) && (Log() << Verbose(1) << "Unselecting molecules with chemical formula " << formula << ":" << endl);
+  std::vector<molecule *> matchingMolecules = World::getInstance().getAllMolecules(MoleculeByFormula(formula));
+  for (std::vector<molecule *>::const_iterator iter = matchingMolecules.begin(); iter != matchingMolecules.end(); ++iter) {
+    DoLog(1) && (Log() << Verbose(1) << "\t" << (*iter)->getId() << ", " << (*iter)->getName() << "." << endl);
+  }
+  World::getInstance().unselectAllMolecules(MoleculeByFormula(formula));
+  return Action::state_ptr(new SelectionNotMoleculeByFormulaState(selectedMolecules,formula));
+}
+
+Action::state_ptr SelectionNotMoleculeByFormulaAction::performUndo(Action::state_ptr _state) {
+  SelectionNotMoleculeByFormulaState *state = assert_cast<SelectionNotMoleculeByFormulaState*>(_state.get());
+
+  World::getInstance().clearMoleculeSelection();
+  for(std::vector<molecule *>::iterator iter = state->selectedMolecules.begin(); iter != state->selectedMolecules.end(); ++iter)
+    World::getInstance().selectMolecule(*iter);
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr SelectionNotMoleculeByFormulaAction::performRedo(Action::state_ptr _state){
+  SelectionNotMoleculeByFormulaState *state = assert_cast<SelectionNotMoleculeByFormulaState*>(_state.get());
+
+  World::getInstance().unselectAllMolecules(MoleculeByFormula(state->formula));
+
+  return Action::state_ptr(_state);
+}
+
+bool SelectionNotMoleculeByFormulaAction::canUndo() {
+  return true;
+}
+
+bool SelectionNotMoleculeByFormulaAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionNotMoleculeByFormulaAction::getName() {
+  return NAME;
+}
Index: src/Actions/SelectionAction/NotMoleculeByFormulaAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByFormulaAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/NotMoleculeByFormulaAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,38 @@
+/*
+ * NotMoleculeByFormulaAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef NOTMOLECULEBYFORMULAACTION_HPP_
+#define NOTMOLECULEBYFORMULAACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class molecule;
+
+void SelectionNotMoleculeByFormula(molecule *_mol);
+
+class SelectionNotMoleculeByFormulaAction : public Action {
+  friend void SelectionNotMoleculeByFormula(const std::string &_formula);
+
+public:
+  SelectionNotMoleculeByFormulaAction();
+  virtual ~SelectionNotMoleculeByFormulaAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* NOTMOLECULEBYFORMULAACTION_HPP_ */
Index: src/Actions/SelectionAction/NotMoleculeByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByIdAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/NotMoleculeByIdAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,106 @@
+/*
+ * NotMoleculeByIdAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/SelectionAction/NotMoleculeByIdAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "molecule.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// memento to remember the state when undoing
+
+class SelectionNotMoleculeByIdState : public ActionState {
+public:
+  SelectionNotMoleculeByIdState(molecule* _mol) :
+    mol(_mol)
+  {}
+  molecule* mol;
+};
+
+const char SelectionNotMoleculeByIdAction::NAME[] = "unselect-molecule-by-id";
+
+SelectionNotMoleculeByIdAction::SelectionNotMoleculeByIdAction() :
+  Action(NAME)
+{}
+
+SelectionNotMoleculeByIdAction::~SelectionNotMoleculeByIdAction()
+{}
+
+void SelectionNotMoleculeById(molecule *_mol) {
+  ValueStorage::getInstance().setCurrentValue(SelectionNotMoleculeByIdAction::NAME, _mol);
+  ActionRegistry::getInstance().getActionByName(SelectionNotMoleculeByIdAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* SelectionNotMoleculeByIdAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryMolecule(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
+Action::state_ptr SelectionNotMoleculeByIdAction::performCall() {
+  molecule *mol = NULL;
+
+  ValueStorage::getInstance().queryCurrentValue(NAME, mol);
+
+  if (World::getInstance().isSelected(mol)) {
+    DoLog(1) && (Log() << Verbose(1) << "Unselecting molecule " << mol->name << endl);
+    World::getInstance().unselectMolecule(mol);
+    return Action::state_ptr(new SelectionNotMoleculeByIdState(mol));
+  } else {
+    return Action::success;
+  }
+}
+
+Action::state_ptr SelectionNotMoleculeByIdAction::performUndo(Action::state_ptr _state) {
+  SelectionNotMoleculeByIdState *state = assert_cast<SelectionNotMoleculeByIdState*>(_state.get());
+
+  if (state->mol != NULL)
+    World::getInstance().selectMolecule(state->mol);
+
+  return Action::state_ptr(new SelectionNotMoleculeByIdState(state->mol));
+}
+
+Action::state_ptr SelectionNotMoleculeByIdAction::performRedo(Action::state_ptr _state){
+  SelectionNotMoleculeByIdState *state = assert_cast<SelectionNotMoleculeByIdState*>(_state.get());
+
+  if (state->mol != NULL)
+    World::getInstance().unselectMolecule(state->mol);
+
+  return Action::state_ptr(new SelectionNotMoleculeByIdState(state->mol));
+}
+
+bool SelectionNotMoleculeByIdAction::canUndo() {
+  return true;
+}
+
+bool SelectionNotMoleculeByIdAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionNotMoleculeByIdAction::getName() {
+  return NAME;
+}
Index: src/Actions/SelectionAction/NotMoleculeByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByIdAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/NotMoleculeByIdAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,38 @@
+/*
+ * NotMoleculeByIdAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef NOTMOLECULEBYIDACTION_HPP_
+#define NOTMOLECULEBYIDACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class molecule;
+
+void SelectionNotMoleculeById(molecule *_mol);
+
+class SelectionNotMoleculeByIdAction : public Action {
+  friend void SelectionNotMoleculeById(molecule *_mol);
+
+public:
+  SelectionNotMoleculeByIdAction();
+  virtual ~SelectionNotMoleculeByIdAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* NOTMOLECULEBYIDACTION_HPP_ */
Index: src/Actions/SelectionAction/NotMoleculeOfAtomAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeOfAtomAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/NotMoleculeOfAtomAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,105 @@
+/*
+ * NotMoleculeOfAtomAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/SelectionAction/NotMoleculeOfAtomAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/MoleculeDescriptor.hpp"
+#include "atom.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// memento to remember the state when undoing
+
+class SelectionNotMoleculeOfAtomState : public ActionState {
+public:
+  SelectionNotMoleculeOfAtomState(std::vector<molecule*> selectedMolecules, atom *_Walker) :
+    selectedMolecules(selectedMolecules),
+    Walker(_Walker)
+  {}
+  std::vector<molecule*> selectedMolecules;
+  atom *Walker;
+};
+
+const char SelectionNotMoleculeOfAtomAction::NAME[] = "unselect-molecule-of-atom";
+
+SelectionNotMoleculeOfAtomAction::SelectionNotMoleculeOfAtomAction() :
+  Action(NAME)
+{}
+
+SelectionNotMoleculeOfAtomAction::~SelectionNotMoleculeOfAtomAction()
+{}
+
+void SelectionNotMoleculeOfAtom() {
+  ActionRegistry::getInstance().getActionByName(SelectionNotMoleculeOfAtomAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* SelectionNotMoleculeOfAtomAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryAtom(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
+Action::state_ptr SelectionNotMoleculeOfAtomAction::performCall() {
+  atom *Walker = NULL;
+
+  ValueStorage::getInstance().queryCurrentValue(NAME, Walker);
+
+  std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
+  DoLog(1) && (Log() << Verbose(1) << "Unselecting molecule to which " << Walker->getName() << " belongs." << endl);
+  World::getInstance().unselectMoleculeOfAtom(Walker);
+  return Action::state_ptr(new SelectionNotMoleculeOfAtomState(selectedMolecules, Walker));
+}
+
+Action::state_ptr SelectionNotMoleculeOfAtomAction::performUndo(Action::state_ptr _state) {
+  SelectionNotMoleculeOfAtomState *state = assert_cast<SelectionNotMoleculeOfAtomState*>(_state.get());
+
+  World::getInstance().clearMoleculeSelection();
+  for(std::vector<molecule *>::iterator iter = state->selectedMolecules.begin(); iter != state->selectedMolecules.end(); ++iter)
+    World::getInstance().selectMolecule(*iter);
+
+  return Action::state_ptr(new SelectionNotMoleculeOfAtomState(state->selectedMolecules, state->Walker));
+}
+
+Action::state_ptr SelectionNotMoleculeOfAtomAction::performRedo(Action::state_ptr _state){
+  SelectionNotMoleculeOfAtomState *state = assert_cast<SelectionNotMoleculeOfAtomState*>(_state.get());
+
+  World::getInstance().unselectMoleculeOfAtom(state->Walker);
+
+  return Action::state_ptr(new SelectionNotMoleculeOfAtomState(state->selectedMolecules, state->Walker));
+}
+
+bool SelectionNotMoleculeOfAtomAction::canUndo() {
+  return true;
+}
+
+bool SelectionNotMoleculeOfAtomAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionNotMoleculeOfAtomAction::getName() {
+  return NAME;
+}
Index: src/Actions/SelectionAction/NotMoleculeOfAtomAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeOfAtomAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/NotMoleculeOfAtomAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,36 @@
+/*
+ * NotMoleculeOfAtomAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef NOTMOLECULEOFATOMSACTION_HPP_
+#define NOTMOLECULEOFATOMSACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+void SelectionNotMoleculeOfAtom();
+
+class SelectionNotMoleculeOfAtomAction : public Action {
+  friend void SelectionNotMoleculeOfAtom();
+
+public:
+  SelectionNotMoleculeOfAtomAction();
+  virtual ~SelectionNotMoleculeOfAtomAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* NOTMOLECULEOFATOMSACTION_HPP_ */
Index: src/Actions/TesselationAction/ConvexEnvelopeAction.cpp
===================================================================
--- src/Actions/TesselationAction/ConvexEnvelopeAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/TesselationAction/ConvexEnvelopeAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,21 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/TesselationAction/ConvexEnvelopeAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "boundary.hpp"
+#include "config.hpp"
+#include "linkedcell.hpp"
+#include "Helpers/Log.hpp"
+#include "molecule.hpp"
+#include "tesselation.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
 
 #include <iostream>
@@ -17,14 +31,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
-
-#include "atom.hpp"
-#include "boundary.hpp"
-#include "config.hpp"
-#include "linkedcell.hpp"
-#include "log.hpp"
-#include "molecule.hpp"
-#include "verbose.hpp"
-#include "World.hpp"
+#include "Actions/ValueStorage.hpp"
 
 /****** TesselationConvexEnvelopeAction *****/
@@ -51,17 +56,32 @@
 {}
 
+void TesselationConvexEnvelope(std::string &filenameConvex, std::string &filenameNonConvex) {
+  ValueStorage::getInstance().setCurrentValue("convex-file", filenameConvex);
+  ValueStorage::getInstance().setCurrentValue("nonconvex-file", filenameConvex);
+  ActionRegistry::getInstance().getActionByName(TesselationConvexEnvelopeAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* TesselationConvexEnvelopeAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
+  dialog->queryString("convex-file", ValueStorage::getInstance().getDescription("convex-file"));
+  dialog->queryString("nonconvex-file", ValueStorage::getInstance().getDescription("nonconvex-file"));
+
+  return dialog;
+}
+
 Action::state_ptr TesselationConvexEnvelopeAction::performCall() {
   string filenameConvex;
   string filenameNonConvex;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   molecule * mol = NULL;
-  bool Success = false;
+  bool Success = true;
   config *configuration = World::getInstance().getConfig();
 
-  dialog->queryMolecule(NAME, &mol, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryString("convex-file", &filenameConvex, MapOfActions::getInstance().getDescription("convex-file"));
-  dialog->queryString("nonconvex-file", &filenameNonConvex, MapOfActions::getInstance().getDescription("nonconvex-file"));
+  ValueStorage::getInstance().queryCurrentValue("convex-file", filenameConvex);
+  ValueStorage::getInstance().queryCurrentValue("nonconvex-file", filenameNonConvex);
 
-  if(dialog->display()) {
+  for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
+    mol = iter->second;
     class Tesselation *TesselStruct = NULL;
     const LinkedCell *LCList = NULL;
@@ -70,5 +90,5 @@
     DoLog(1) && (Log() << Verbose(1) << "Storing tecplot non-convex data in " << filenameNonConvex << "." << endl);
     LCList = new LinkedCell(mol, 100.);
-    Boundaries *BoundaryPoints = NULL;
+    //Boundaries *BoundaryPoints = NULL;
     //FindConvexBorder(mol, BoundaryPoints, TesselStruct, LCList, argv[argptr]);
     // TODO: Beide Funktionen sollten streams anstelle des Filenamen benutzen, besser fuer unit tests
@@ -81,12 +101,9 @@
     delete(TesselStruct);
     delete(LCList);
-    delete dialog;
-    if (Success)
-      return Action::success;
-    else
-      return Action::failure;
   }
-  delete dialog;
-  return Action::failure;
+  if (Success)
+    return Action::success;
+  else
+    return Action::failure;
 }
 
Index: src/Actions/TesselationAction/ConvexEnvelopeAction.hpp
===================================================================
--- src/Actions/TesselationAction/ConvexEnvelopeAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/TesselationAction/ConvexEnvelopeAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,9 +10,13 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+
 
 class TesselationListClass;
 
+void TesselationConvexEnvelope(std::string &filenameConvex, std::string &filenameNonConvex);
+
 class TesselationConvexEnvelopeAction : public Action {
+  friend void TesselationConvexEnvelope(std::string &filenameConvex, std::string &filenameNonConvex);
+
 public:
   TesselationConvexEnvelopeAction();
@@ -23,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp
===================================================================
--- src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,20 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/TesselationAction/NonConvexEnvelopeAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "boundary.hpp"
+#include "linkedcell.hpp"
+#include "Helpers/Log.hpp"
+#include "molecule.hpp"
+#include "tesselation.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
 
 #include <iostream>
@@ -17,13 +30,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
-
-#include "atom.hpp"
-#include "boundary.hpp"
-#include "linkedcell.hpp"
-#include "log.hpp"
-#include "molecule.hpp"
-#include "verbose.hpp"
-#include "World.hpp"
+#include "Actions/ValueStorage.hpp"
 
 /****** TesselationNonConvexEnvelopeAction *****/
@@ -50,7 +55,21 @@
 {}
 
+void TesselationNonConvexEnvelope(double radius, std::string &filename) {
+  ValueStorage::getInstance().setCurrentValue(TesselationNonConvexEnvelopeAction::NAME, radius);
+  ValueStorage::getInstance().setCurrentValue("nonconvex-file", filename);
+  ActionRegistry::getInstance().getActionByName(TesselationNonConvexEnvelopeAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* TesselationNonConvexEnvelopeAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryDouble(NAME, ValueStorage::getInstance().getDescription(NAME));
+  dialog->queryString("nonconvex-file", ValueStorage::getInstance().getDescription("nonconvex-file"));
+
+  return dialog;
+}
+
 Action::state_ptr TesselationNonConvexEnvelopeAction::performCall() {
   string filename;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   molecule * Boundary = NULL;
   double SphereRadius = 0;
@@ -58,9 +77,9 @@
   clock_t start,end;
 
-  dialog->queryMolecule(NAME, &Boundary, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryString("nonconvex-file", &filename, MapOfActions::getInstance().getDescription("nonconvex-file"));
-  dialog->queryDouble("sphere-radius", &SphereRadius, MapOfActions::getInstance().getDescription("sphere-radius"));
+  ValueStorage::getInstance().queryCurrentValue(NAME, SphereRadius);
+  ValueStorage::getInstance().queryCurrentValue("nonconvex-file", filename);
 
-  if(dialog->display()) {
+  for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
+    Boundary = iter->second;
     class Tesselation *T = NULL;
     const LinkedCell *LCList = NULL;
@@ -76,12 +95,9 @@
     delete(LCList);
     delete(T);
-    delete dialog;
-    if (Success)
-      return Action::success;
-    else
-      return Action::failure;
   }
-  delete dialog;
-  return Action::failure;
+  if (Success)
+    return Action::success;
+  else
+    return Action::failure;
 }
 
Index: src/Actions/TesselationAction/NonConvexEnvelopeAction.hpp
===================================================================
--- src/Actions/TesselationAction/NonConvexEnvelopeAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/TesselationAction/NonConvexEnvelopeAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,9 +10,13 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+
 
 class TesselationListClass;
 
+void TesselationNonConvexEnvelope(double radius, std::string &filename);
+
 class TesselationNonConvexEnvelopeAction : public Action {
+  friend void TesselationNonConvexEnvelope(double radius, std::string &filename);
+
 public:
   TesselationNonConvexEnvelopeAction();
@@ -23,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/ValueStorage.cpp
===================================================================
--- src/Actions/ValueStorage.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/ValueStorage.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,28 @@
+/*
+ * ValueStorage.cpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "ValueStorage.hpp"
+#include "Patterns/Singleton_impl.hpp"
+
+ValueStorage::ValueStorage() :
+  MapOfActions_instance(MapOfActions::getInstance())
+{};
+
+ValueStorage::~ValueStorage() {};
+
+std::string ValueStorage::getDescription(std::string actionname) {
+  return MapOfActions::getInstance().getDescription(actionname);
+}
+
+CONSTRUCT_SINGLETON(ValueStorage)
Index: src/Actions/ValueStorage.hpp
===================================================================
--- src/Actions/ValueStorage.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/ValueStorage.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,59 @@
+/*
+ * ValueStorage.hpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: heber
+ */
+
+#ifndef VALUESTORAGE_HPP_
+#define VALUESTORAGE_HPP_
+
+#include "Actions/MapOfActions.hpp"
+#include "Patterns/Singleton.hpp"
+
+/** ValueStorage serves as a mediator to MapOfActions.
+ * This is needed to relax inter-dependencies between the Queries and the Actions.
+ * I.e. this is the interface implemented in MapOfActions which both can safely rely on
+ * to store&retrieve/exchange values.
+ */
+class ValueStorage : public Singleton<ValueStorage> {
+  friend class Singleton<ValueStorage>;
+
+public:
+  /** Gets a value from the storage
+   * If the value is not present, an ASSERT is thrown unless optional is set to true.
+   * \param _T key of value
+   * \param optional whether this value is optional, i.e. may actually not be in the storage (i.e. may return false in this case).
+   * \return true - value present, false - value not present (only given when optional set to true)
+   */
+  template <typename T> bool queryCurrentValue(const char *name, T &_T, const bool optional = false) {
+    if (optional) {
+      if (!MapOfActions_instance.isCurrentValuePresent(name))
+        return false;
+    }
+    MapOfActions_instance.queryCurrentValue(name, _T);
+    return true;
+  }
+
+  /** Sets a value in the storage.
+   * \param name key of value
+   * \param _T value
+   */
+  template <typename T> void setCurrentValue(const char *name, T &_T) {
+    MapOfActions_instance.setCurrentValue(name, _T);
+  }
+
+  /** Obtain a descriptive text for a given key.
+   * \param actionname key
+   * \return text describing the key's contents
+   */
+  std::string getDescription(std::string actionname);
+
+protected:
+  ValueStorage();
+  ~ValueStorage();
+
+  MapOfActions &MapOfActions_instance;
+};
+
+#endif /* VALUESTORAGE_HPP_ */
Index: src/Actions/Values.hpp
===================================================================
--- src/Actions/Values.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/Values.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -19,8 +19,8 @@
 {
   double xx;
-  double xy;
-  double xz;
+  double yx;
   double yy;
-  double yz;
+  double zx;
+  double zy;
   double zz;
 };
